#include "stdafx.h"
#include "CAttachmentDropTargetApp.hpp"
#include "CatHelp.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

CAttachmentDropTargetApp App;

const GUID CDECL BASED_CODE _tlid =
	{0x3B0ADE7E, 0xD143, 0x4B67, {0x9B, 0x4D, 0xF3, 0x5F, 0xA4, 0xF9, 0x58, 0x7D}}
;
const WORD _wVerMajor = 1;
const WORD _wVerMinor = 0;

//
// DLL initialization.
//
BOOL CAttachmentDropTargetApp::InitInstance()
{
	BOOL bInit = COleControlModule::InitInstance();
	if (bInit)
	{

		// TODO:  Add code for initializing your own modules here.
	}
	return bInit;
}

//
// DLL termination.
//
int CAttachmentDropTargetApp::ExitInstance()
{

	// TODO:  Add code for exiting your own modules here.
	return COleControlModule::ExitInstance();
}

const CATID CATID_SafeForScripting =
	{0x7dd95801,0x9882,0x11cf,{0x9f,0xa9,0x00,0xaa,0x00,0x6c,0x42,0xc4}}
;
const CATID CATID_SafeForInitializing =
	{0x7dd95802,0x9882,0x11cf,{0x9f,0xa9,0x00,0xaa,0x00,0x6c,0x42,0xc4}}
;

//const GUID CDECL BASED_CODE _ctlid =
//	{0x43bd9e45, 0x328f, 0x11d0, {0xa6, 0xb9, 0x0, 0xaa, 0x0, 0xa7, 0xf, 0xc2}}
//;

//
// Adds registry entries to the system registration.
//
STDAPI DllRegisterServer(void)
{
	AFX_MANAGE_STATE(_afxModuleAddrThis);

	if (!AfxOleRegisterTypeLib(AfxGetInstanceHandle(), _tlid))
		return ResultFromScode(SELFREG_E_TYPELIB);
	if (!COleObjectFactoryEx::UpdateRegistryAll(TRUE))
		return ResultFromScode(SELFREG_E_CLASS);
	if (
		FAILED(
			CreateComponentCategory(
				CATID_SafeForScripting,
				L"Controls that are safely scriptable"
			)
		)
	)
		return ResultFromScode(SELFREG_E_CLASS);
	if (
		FAILED(
			CreateComponentCategory(
				CATID_SafeForInitializing,
				L"Controls safely initializable from persistent data"
			)
		)
	)
		return ResultFromScode(SELFREG_E_CLASS);
	if (FAILED(RegisterCLSIDInCategory(_tlid, CATID_SafeForScripting)))
		return ResultFromScode(SELFREG_E_CLASS);
	if (FAILED(RegisterCLSIDInCategory(_tlid, CATID_SafeForInitializing)))
		return ResultFromScode(SELFREG_E_CLASS);
	return NOERROR;
}

//
// Removes registry entries from the system registration.
//
STDAPI DllUnregisterServer(void)
{
	AFX_MANAGE_STATE(_afxModuleAddrThis);

	if (!AfxOleUnregisterTypeLib(_tlid, _wVerMajor, _wVerMinor))
		return ResultFromScode(SELFREG_E_TYPELIB);
	if (!COleObjectFactoryEx::UpdateRegistryAll(FALSE))
		return ResultFromScode(SELFREG_E_CLASS);
	return NOERROR;
}