#pragma once

#include "afxole.h"

class COleDropWndTarget : public COleDropTarget
{

// Construction.
public:
	COleDropWndTarget();

// Destruction.
public:
	virtual ~COleDropWndTarget();

// Implementation.
public:

	// These members must be overridden for an OLE drop target.

	DROPEFFECT OnDragEnter(
		CWnd *pWnd,
		COleDataObject *pDataObject,
		DWORD dwKeyState,
		CPoint point
	);

	DROPEFFECT OnDragOver(
		CWnd *pWnd,
		COleDataObject *pDataObject,
		DWORD dwKeyState,
		CPoint point
	);

	void OnDragLeave(CWnd *pWnd);

	BOOL OnDrop(
		CWnd *pWnd,
		COleDataObject *pDataObject,
		DROPEFFECT dropEffect,
		CPoint point
	);

// Private members.
private:
	BOOL IsFileDrop(
		COleDataObject *pDataObject
	);

	BOOL ProcessHdrop(
		CWnd *pWnd,
		COleDataObject *pDataObject
	);

	BOOL ProcessFileGroup(
		CWnd *pWnd,
		COleDataObject *pDataObject
	);

	CLIPFORMAT CF_FILECONTENTS;
	CLIPFORMAT CF_FILEGROUPDESCRIPTOR;
};